#
# RSS1Writer
#
# A plugin to XMLWriter to output RSS version 1.0.
#
# (c) 2004, Davyd Madeley <davyd@ucc.asn.au>
#

import time, cgi

class RSS1Writer:
	def __init__(self, planet):
		self.planet	= planet
		self.maxitems	= 50
		self.parent	= None
	
	def __write_item__(self, item):
		output	=	''
		output	+=	'<item rdfAbout="%s">\n' % item.itemURL
		output	+=	' <title>%s: %s</title>\n' % (item.blogTitle, item.itemTitle)
		output	+=	' <link>%s</link>\n' % item.itemURL
		output	+=	' <description>\n'
		output	+=	cgi.escape(item.contents)
		output	+=	'\n </description>\n'
		output	+=	' <dc:date>%s</dc:date>\n' % time.strftime('%Y-%m-%dT%H:%M:%S+08:00', time.gmtime(item.itemDate))
		output	+=	'</item>\n'
		return output
	
	def write(self):
		itemcount	= 0
		output	=	''
		output	+=	'<rdf:RDF>\n'
		output	+=	' xmlns="http://purl.org/rss/1.0/"\n'
		output	+=	' xmlns:dc="http://purl.org/dc/elements/1.1/"\n'
		output	+=	' xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n'
		output	+=	' <channel>\n'
		output	+=	'  <title>Planet UCC</title>\n'
		output	+=	'  <link>http://planet.ucc.asn.au/</link>\n'
		output	+=	'  <items>\n'
		output	+=	'   <rdf:Seq>\n'
		for blog in self.parent.blogs:
			output	+=	'    <rdf:li rdf:resource="%s" />\n' % blog.feedURL
		output	+=	'   </rdf:Seq>\n'
		output	+=	'  </items>\n'
		output	+=	' </channel>\n'
		for date in self.planet:
			for item in date.items:
				output	+= self.__write_item__(item)
				itemcount += 1
				if itemcount >= self.maxitems:
					break
			if itemcount >= self.maxitems:
				break
		output	+=	'</rdf:RDF>'
		return output
